from typing import Dict, Optional, Tuple

import multipart

class Part:
    headers = []
    data : bytes

def get_body_from_form_data(
    body: bytes, boundary: str
) -> Tuple[Optional[bytes], Dict[str, str]]:
    print("YO BYTES", body)

    current_part = Part()
    parts = []

    def on_part_begin():
        current_part = Part()
        print("YO PART BEGAN")
        return

    def on_part_data(b,s,e):
        current_part.data = b[s:e]
        print("YO PART DATA", b[s:e])
        return

    def on_part_end():
        parts.append(current_part)
        print("YO PART ENDED")
        return

    def on_header_begin():
        print("YO HEADER BEGIN")
        return

    def on_header_end():
        print("YO HEADER END")
        return

    def on_header_field(b,s,e):
        current_part.headers.append({ name : b[s:e], value: ""})
        print("YO HEADER FIELD", )
        return

    def on_header_value(b,s,e):
        current_part.headers[-1].value = b[s:e]
        print("YO HEADER VALUE", b[s:e])
        return

    def on_headers_finished():
        print("YO HEADER FINISHED")
        return

    def on_end():
        print("YO END")
        return

    parser = multipart.MultipartParser(boundary=boundary,
                                       callbacks={
                                           "on_part_begin": on_part_begin,
                                           "on_part_data": on_part_data,
                                           "on_part_end": on_part_end,
                                           "on_header_field": on_header_field,
                                           "on_header_value": on_header_value,
                                           "on_header_end": on_header_end,
                                           "on_headers_finished": on_headers_finished,
                                           "on_end": on_end,
                                       }
                                       )
    parser.write(body)
    parser.finalize(body)

    print("YO PARTS", parts)
    data = None
    headers: Dict[str, str] = {}
    for prt in parser.parts():
        if prt.name == "upload_file":
            headers["key"] = prt.name
            data = prt.file.read()
        else:
            val = prt.file.read()
            if prt.name == "file":
                data = val
            else:
                headers[prt.name] = val.decode("utf-8")
    return data, headers

# form_data file
# form_data key
